/* -*- C++ -*-
 * $Id: flbitmap.cc,v 1.7 2006/12/29 05:02:40 jeremy_henty Exp $
 */

#include "fltk.h"
#include "flwidget.h"
#include "flbitmap.h"

VALUE rb_cFLBitmap;

static void rb_FLBitmap_free(RBFLBitmap *bitmap)
{
};

static VALUE rb_FLBitmap_new(VALUE klass, RBFLBitmap *bitmap)
{
  VALUE obj;
  obj = Data_Wrap_Struct(klass, 0, rb_FLBitmap_free, bitmap);
  rb_fltk_objmap_aset((Fl_Widget*)bitmap, obj);
  return obj;
};

static VALUE rb_FLBitmap_initialize(int argc, VALUE argv[], VALUE self)
{
  return Qnil;
};

static VALUE rb_FLBitmap_s_new(int argc, VALUE argv[], VALUE klass)
{
  VALUE obj, xbm, w, h;
  RBFLBitmap *bitmap;
  char *data;
  char *rb_fltk_create_bitmap(VALUE);

  rb_scan_args(argc, argv, "30", &xbm,&w,&h);

  Check_Type(xbm, T_ARRAY);
  data = rb_fltk_create_bitmap(xbm);
  bitmap = new RBFLBitmap(data,NUM2INT(w),NUM2INT(h));
  obj = rb_FLBitmap_new(klass,bitmap);

  rb_obj_call_init(obj, argc, argv);

  return obj;
};

static VALUE rb_FLBitmap_destroy(VALUE self)
{
  RBFLBitmap *bitmap = (RBFLBitmap*)rb_to_fl(self);

  rb_fltk_objmap_delete((Fl_Widget*)bitmap);
  if( bitmap && bitmap->array ){
    delete[] (bitmap->array);
    delete bitmap;
  };

  return Qnil;
};

static VALUE rb_FLBitmap_label(VALUE self, VALUE vwidget)
{
  RBFLBitmap *bitmap = (RBFLBitmap*)rb_to_fl(self);
  RBFLWidget *widget = (RBFLWidget*)rb_to_fl(vwidget);

  bitmap->label(widget);

  return Qnil;
};

static VALUE rb_FLBitmap_draw(int argc, VALUE argv[], VALUE self)
{
  RBFLBitmap *bitmap = (RBFLBitmap*)rb_to_fl(self);
  VALUE arg1, arg2, arg3, arg4, arg5, arg6;
  int x, y, w, h, cx, cy;

  switch( rb_scan_args(argc, argv, "24", &arg1,&arg2,&arg3,&arg4,&arg5,&arg6) ){
  case 2:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    bitmap->draw(x,y);
    break;
  case 4:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    w = NUM2INT(arg3);
    h = NUM2INT(arg4);
    bitmap->draw(x,y,w,h);
    break;
  case 6:
    x = NUM2INT(arg1);
    y = NUM2INT(arg2);
    w = NUM2INT(arg3);
    h = NUM2INT(arg4);
    cx = NUM2INT(arg5);
    cy = NUM2INT(arg6);
    bitmap->draw(x,y,w,h,cx,cy);
    break;
  default:
    rb_raise(rb_eArgError, "too few/many arguments");
  };

  return Qnil;
};

extern "C" void
Init_flbitmap(){
  rb_cFLBitmap = rb_define_class_under(rb_mFLTK, "Bitmap", rb_cObject);
  DEF_S_METHOD(Bitmap, new, -1);
  DEF_INIT_METHOD(Bitmap);
  DEF_METHOD(Bitmap, destroy, 0);
  DEF_METHOD(Bitmap, label, 1);
  DEF_METHOD(Bitmap, draw, -1);
};
