/* -*- C++ -*-
 * $Id: flbutton.cc,v 1.28 2006/12/22 22:33:27 jeremy_henty Exp $
 */

#include "fltk.h"
#include "flbutton.h"
#include "flenum.h"
#include "flcolor.h"

VALUE rb_cFLButton;
VALUE rb_cFLCheck_Button;
VALUE rb_cFLLight_Button;
VALUE rb_cFLRepeat_Button;
VALUE rb_cFLReturn_Button;
VALUE rb_cFLRound_Button;
VALUE rb_cFLToggle_Button;
VALUE rb_cFLToggle_Light_Button;
VALUE rb_cFLToggle_Round_Button;

static FN_S_NEW(Button);
WIDGET_FNS(Button);
static FN_INIT2(Button,size,{
  if( rb_block_given_p() ){
    rb_fl_callback(self);
  };
});
static FN_GETSET_INT(Button,type);
static FN_CALL(Button,clear);
static FN_CALL(Button,set);
static FN_GETSET_INT(Button,value);
static FN_GETSET_ENUM(Button,Fl_Boxtype,down_box);
static FN_CALL(Button,setonly);
static FN_GETSET_INT(Button,shortcut);
static FN_GETSET_COLOR(Button,down_color);

static FN_S_NEW(Check_Button);
WIDGET_FNS(Check_Button);

static FN_S_NEW(Light_Button);
WIDGET_FNS(Light_Button);

static FN_S_NEW(Repeat_Button);
WIDGET_FNS(Repeat_Button);

static FN_S_NEW(Return_Button);
WIDGET_FNS(Return_Button);

static FN_S_NEW(Round_Button);
WIDGET_FNS(Round_Button);

static FN_S_NEW(Toggle_Button);
WIDGET_FNS(Toggle_Button);

static FN_S_NEW(Toggle_Light_Button);
WIDGET_FNS(Toggle_Light_Button);

static FN_S_NEW(Toggle_Round_Button);
WIDGET_FNS(Toggle_Round_Button);

extern "C" void
Init_flbutton(){
  /* Button Types */
  DEF_MODULE_CONST_NUM(NORMAL_BUTTON);
  DEF_MODULE_CONST_NUM(TOGGLE_BUTTON);
  DEF_MODULE_CONST_NUM(RADIO_BUTTON);
  DEF_MODULE_CONST_NUM(HIDDEN_BUTTON);

  rb_cFLButton = rb_define_class_under(rb_mFLTK, "Button", rb_cFLWidget);
  DEF_S_METHOD(Button,new,-1);
  DEF_WIDGET_METHODS(Button);
  DEF_PREFIXED_METHOD_EQ(Button, button, type, -1);
  DEF_INIT_METHOD(Button);
  DEF_METHOD_EQ(Button, value, -1);
  DEF_METHOD_EQ(Button, down_box, -1);
  DEF_METHOD(Button, setonly, 0);
  DEF_METHOD(Button, clear, 0);
  DEF_METHOD_EQ(Button, shortcut, -1);
  DEF_METHOD(Button, set, 0);
  DEF_METHOD_EQ(Button, down_color, -1);

  rb_cFLCheck_Button = rb_define_class_under(rb_mFLTK, "CheckButton", rb_cFLButton);
  DEF_S_METHOD(Check_Button,new,-1);
  DEF_WIDGET_METHODS(Check_Button);

  rb_cFLLight_Button = rb_define_class_under(rb_mFLTK, "LightButton", rb_cFLButton);
  DEF_S_METHOD(Light_Button,new,-1);
  DEF_WIDGET_METHODS(Light_Button);

  rb_cFLRepeat_Button = rb_define_class_under(rb_mFLTK, "RepeatButton", rb_cFLButton);
  DEF_S_METHOD(Repeat_Button,new,-1);
  DEF_WIDGET_METHODS(Repeat_Button);

  rb_cFLReturn_Button = rb_define_class_under(rb_mFLTK, "ReturnButton", rb_cFLButton);
  DEF_S_METHOD(Return_Button,new,-1);
  DEF_WIDGET_METHODS(Return_Button);

  rb_cFLRound_Button = rb_define_class_under(rb_mFLTK, "RoundButton", rb_cFLButton);
  DEF_S_METHOD(Round_Button,new,-1);
  DEF_WIDGET_METHODS(Round_Button);

  rb_cFLToggle_Button = rb_define_class_under(rb_mFLTK, "ToggleButton", rb_cFLButton);
  DEF_S_METHOD(Toggle_Button,new,-1);
  DEF_WIDGET_METHODS(Toggle_Button);

  rb_cFLToggle_Light_Button = rb_define_class_under(rb_mFLTK, "ToggleLightButton", rb_cFLButton);
  DEF_S_METHOD(Toggle_Light_Button,new,-1);
  DEF_WIDGET_METHODS(Toggle_Light_Button);

  rb_cFLToggle_Round_Button = rb_define_class_under(rb_mFLTK, "ToggleRoundButton", rb_cFLButton);
  DEF_S_METHOD(Toggle_Round_Button,new,-1);
  DEF_WIDGET_METHODS(Toggle_Round_Button);
};
