/* -*- C++ -*-
 * $Id: flclock.cc,v 1.9 2006/12/22 22:33:27 jeremy_henty Exp $
 */

#include "fltk.h"
#include "flclock.h"
#include "flenum.h"

VALUE rb_cFLClock;

static FN_S_NEW(Clock);
WIDGET_FNS(Clock);
static FN_GET_INT(Clock,hour);
static FN_GET_INT(Clock,minute);
static FN_GET_INT(Clock,second);

static VALUE rb_FLClock_value(int argc, VALUE argv[], VALUE self)
{
  RBFLClock *clock = (RBFLClock*)rb_to_fl(self);
  VALUE a1,a2,a3; /* parameters */

  switch( rb_scan_args(argc, argv, "03", &a1, &a2, &a3) ){
  case 0:
    return UINT2NUM(clock->value());
  case 1:
    clock->value(NUM2UINT(a1));
    return Qnil;
  case 2:
    clock->value(NUM2INT(a1),NUM2INT(a2),0);
    return Qnil;
  case 3:
    clock->value(NUM2INT(a1),NUM2INT(a2),NUM2INT(a3));
    return Qnil;
  }
};

extern "C" void
Init_flclock(){
  rb_cFLClock = rb_define_class_under(rb_mFLTK, "Clock", rb_cFLWidget);
  DEF_S_METHOD(Clock,new,-1);
  DEF_WIDGET_METHODS(Clock);
  DEF_METHOD(Clock,hour,0);
  DEF_METHOD(Clock,minute,0);
  DEF_METHOD(Clock,second,0);
  DEF_METHOD_EQ(Clock,value,-1);

  DEF_MODULE_CONST_NUM(ANALOG_CLOCK);
  DEF_MODULE_CONST_NUM(DIGITAL_CLOCK);
  DEF_MODULE_CONST_NUM(ROUND_CLOCK);
  DEF_MODULE_CONST_NUM(SQUARE_CLOCK);
};
