/* -*- C++ -*-
 * $Id: flcolor.h,v 1.3 2006/05/01 08:23:38 jeremy_henty Exp $
 */

#ifndef RBFLCOLOR_H
#define RBFLCOLOR_H

#include "flenum.h"

#ifdef USE_COLOR_CLASSES

extern VALUE rb_fltk_color_to_value(Fl_Color color);
extern Fl_Color rb_fltk_value_to_color(VALUE value);

#define VALUE2COLOR(x) \
rb_fltk_value_to_color((VALUE)(x))
#define COLOR2VALUE(x) \
rb_fltk_color_to_value((Fl_Color)(x))

#else // #ifdef USE_COLOR_CLASSES 

#define VALUE2COLOR(x) \
((Fl_Color)(NUM2INT(x)))
#define COLOR2VALUE(x) \
INT2NUM(x)

#endif // #ifdef USE_COLOR_CLASSES 

#define FN_GETSET_COLOR(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *widget = (RBFL##klass*)rb_to_fl(self); \
  VALUE arg1; \
  switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
  case 0: \
    return COLOR2VALUE(widget->method()); \
  case 1: \
    widget->method(VALUE2COLOR(arg1)); \
    return Qnil; \
  }; \
};

#define FN_SET_COLOR_DBL(klass,method) \
VALUE rb_FL##klass##_##method(VALUE self, VALUE arg1, VALUE arg2){ \
  RBFL##klass *widget = (RBFL##klass*)rb_to_fl(self); \
  widget->method(VALUE2COLOR(arg1), RFLOAT(rb_Float(arg2))->value); \
  return Qnil; \
};

#define FN_GETSET_COLOR2(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *widget = (RBFL##klass*)rb_to_fl(self); \
  VALUE arg1, arg2; \
  switch( rb_scan_args(argc, argv, "02", &arg1, &arg2) ){ \
  case 0: \
    return COLOR2VALUE(widget->method()); \
  case 1: \
    widget->method(VALUE2COLOR(arg1)); \
    return Qnil; \
  case 2: \
    widget->method(VALUE2COLOR(arg1), VALUE2COLOR(arg2)); \
    return Qnil; \
  }; \
};

#define FN_SET_ENUM_OPTCOLOR2(klass, ty1, method) \
  VALUE rb_FL##klass##_##method(VALUE argc, VALUE argv[], VALUE self) { \
    RBFL##klass* widget = (RBFL##klass*)rb_to_fl(self); \
    VALUE arg1, arg2, arg3; \
    switch( rb_scan_args(argc, argv, "12", &arg1, &arg2, &arg3) ){ \
      case 1: \
        widget->method((ty1)NUM2INT(arg1)); \
        break; \
      case 2: \
        widget->method((ty1)NUM2INT(arg1), VALUE2COLOR(arg2)); \
	break; \
      case 3: \
        widget->method((ty1)NUM2INT(arg1), VALUE2COLOR(arg2), VALUE2COLOR(arg3)); \
	break; \
    } \
    return Qnil; \
  };

#define FN_GLOBAL_GET_COLOR_SET_COLOR(method) \
  VALUE rb_fltk_##method(VALUE self, VALUE x) { \
    return COLOR2VALUE( fl_##method(VALUE2COLOR(x)) ); \
  };

#define FN_GLOBAL_GETSET_COLOR(method) \
  VALUE rb_fltk_##method(VALUE argc, VALUE argv[], VALUE self) { \
    VALUE arg1; \
    switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
      case 0: \
        return COLOR2VALUE(fl_##method()); \
      case 1: \
        fl_##method(VALUE2COLOR(arg1)); \
		break; \
    } \
    return Qnil; \
  };

#define FN_GL_GLOBAL_SET_COLOR(method) \
  VALUE rb_fltk_##gl_##method(VALUE self, VALUE x) { \
    gl_##method(VALUE2COLOR(x)); \
    return Qnil; \
  };

extern "C" void Init_flcolor(void);

#endif /* RBFLCOLOR_H */
