/* -*- C++ -*-
 * $Id: flscroll.cc,v 1.13 2006/12/25 18:22:29 jeremy_henty Exp $
 */

#include "fltk.h"
#include "flscroll.h"

#define DEF_SCROLL_CONST_NUM(c) \
  rb_define_const(rb_cFLScroll,#c,INT2NUM(Fl_Scroll::c))

VALUE rb_cFLScroll;

static FN_S_NEW(Scroll);
WIDGET_FNS(Scroll);
static FN_GETSET_INT(Scroll, type);
static FN_GET_INT(Scroll, xposition);
static FN_GET_INT(Scroll, yposition);
static FN_SET_INT2(Scroll, position);

extern "C" void
Init_flscroll(){
  rb_cFLScroll = rb_define_class_under(rb_mFLTK, "Scroll", rb_cFLGroup);
  DEF_S_METHOD(Scroll,new,-1);
  DEF_WIDGET_METHODS(Scroll);
  DEF_PREFIXED_METHOD_EQ(Scroll,scroll,type,-1);
  DEF_METHOD(Scroll,xposition,0);
  DEF_METHOD(Scroll,yposition,0);
  DEF_METHOD(Scroll,position,2);

  DEF_SCROLL_CONST_NUM(HORIZONTAL);
  DEF_SCROLL_CONST_NUM(VERTICAL);
  DEF_SCROLL_CONST_NUM(BOTH);
  DEF_SCROLL_CONST_NUM(HORIZONTAL_ALWAYS);
  DEF_SCROLL_CONST_NUM(VERTICAL_ALWAYS);
  DEF_SCROLL_CONST_NUM(BOTH_ALWAYS);
  DEF_SCROLL_CONST_NUM(ALWAYS_ON);
};
