# $Id: image.rb,v 1.9 2006/12/31 11:58:23 jeremy_henty Exp $

require 'fltk'

PREFIX = File.dirname($0)

FLTK::Window.new(400,600,"Images"){|win|

  jpg = FLTK::JPEGImage.new(File.join(PREFIX,"ruby.jpg"))
  gif = FLTK::GIFImage.new(File.join(PREFIX,"ruby.gif"))
  bmp = FLTK::BMPImage.new(File.join(PREFIX,"ruby.bmp"))
  png = FLTK::PNGImage.new(File.join(PREFIX,"ruby.png"))

  xpmimg,xpmw,xpmh = FLTK.load_pixmap(File.join(PREFIX,"ruby.xpm"))
  xpm = FLTK::Pixmap.new(xpmimg)
  xbmimg,xbmw,xbmh = FLTK.load_bitmap(File.join(PREFIX,"ruby.xbm"))
  xbm = FLTK::Bitmap.new(xbmimg,xbmw,xbmh)

  border = 10
  bw = (win.w-3*border)/2
  bh = (win.h-4*border)/3
  x1 = border
  x2 = border+bw+border
  y1 = border
  y2 = border+bh+border
  y3 = border+2*(bh+border)

  [ [x1,y1,"JPG",jpg],
    [x2,y1,"GIF",gif],
    [x1,y2,"BMP",bmp],
    [x2,y2,"PNG",png],
    [x1,y3,"XBM",xbm],
    [x2,y3,"XPM",xpm],
  ].each{|x,y,label,img|
    box = FLTK::Box.new(x,y,bw,bh,label)
    box.box = FLTK::UP_BOX
    img.label(box)
  }

  win.show

}

FLTK.run
