# $Id: beep.rb,v 1.3 2006/12/31 11:58:23 jeremy_henty Exp $

require 'fltk'

FLTK::Window.new(335,60,"Beep test"){|win|

  message = nil # will set this later 

  # a button that calls "FLTK.beep" with the current arguments
  beep_arguments = [ ]
  FLTK::Button.new(0,0,50,30,"Beep") do
    FLTK.beep(*beep_arguments)
    message.label("Beep: #{beep_arguments.join(" ")}")
  end

  # the list of beep constants (NB: we push "BEEP_DEFAULT" to the
  # head)
  beep_constants = FLTK::Const.constants.grep(/^BEEP/).sort
  beep_constants.delete("BEEP_DEFAULT")
  beep_constants = [ "BEEP_DEFAULT", ] + beep_constants

  # a choice widget that sets the beep arguments 
  choice_widget =
  FLTK::Choice.new(135,0,200,30,"Arguments")
  callback = Proc.new { |widget,args,| beep_arguments = args } 
  choice_widget.add("<None>","",callback,[],0) 
  beep_constants.each do |b|
    args = [ FLTK::Const.const_get(b), ]
    choice_widget.add(b,"",callback,args,0)
  end
  choice_widget.value(0)

  # message display 
  message = FLTK::Box.new(0,30,win.w,30)

  win.show

}

FLTK.run
