# $Id: check.rb,v 1.10 2007/01/08 04:46:42 jeremy_henty Exp $

require 'fltk'

class Check

  attr_reader :cb_count, :cb_count_box, :toggle, :box

  def initialize(_cb_count_box,
                 _toggle,
                 _box)
    @cb_count_box = _cb_count_box
    @toggle       = _toggle
    @box          = _box
    box.box(FLTK::FLAT_BOX)
    self.cb_count = 0
  end

  def cb_count= _cb_count
    @cb_count = _cb_count
    cb_count_box.label(cb_count.to_s)
  end

end

callback = Proc.new {|check|
  check.box.color =
  check.toggle.value == 1 ? FLTK::WHITE : FLTK::BLACK
  check.box.redraw
}

_x = 0
x0 = _x; _x += w0 = 40
x1 = _x; _x += w1 = 70
x2 = _x; _x += w2 = 30
x3 = _x; _x += w3 = 30
x4 = _x; _x += w4 = 30

check_count = 3

_y = 0 ; _h = 30 ; _w = check_count*_h
FLTK::Window.new(_x,_w,"Check"){|win| 
  check_count.times {
    add_button = FLTK::Button.new(x0,_y,w0,_h,"Add")
    remove_button = FLTK::Button.new(x1,_y,w1,_h,"Remove")
    check = Check.new(FLTK::Box.new(x2,_y,w2,_h),
                      FLTK::ToggleButton.new(x3,_y,w3,_h,"@circle"),
                      FLTK::Box.new(x4,_y,w4,_h))
    add_button.callback {
      FLTK.add_check(callback,check)
      check.cb_count += 1
    }
    remove_button.callback {
      FLTK.remove_check(callback,check)
      check.cb_count = 0
      check.box.color = FLTK::BACKGROUND_COLOR
      check.box.redraw
    }
    _y += _h
  }
  win.show
}

FLTK.run
