# $Id: grounds.rb,v 1.2 2006/12/31 11:58:24 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2006 Jeremy Henty 
# License:: LGPL

=begin

Demonstrate the ColorChooser widget and the
FLTK.{foreground,background,background2} methods.

=end

require 'fltk'

@fltk_method = nil
@chooser = nil
@widgets = Array.new

def chooser_init
  @chooser.rgb(0.5,0.5,0.5)
end

def fltk_method_call
  return unless @fltk_method
  FLTK.send(@fltk_method,
            *[:r,:g,:b,].collect{|_method|
              (@chooser.send(_method)*255).to_i
            })
  @widgets.each{|ww| ww.redraw }
end

FLTK::Window.new(300,120,"Foreground/Background"){|win|

  text = FLTK::Box.new(0,0,300,30,
                       "Select a method, watch this text!")
  text.box(FLTK::FLAT_BOX)
  @widgets << text

  y = 30
  [ :foreground, 
    :background, 
    :background2, 
  ].each{|_method|
    button = FLTK::Button.new(0,y,100,30,_method.to_s){
      @fltk_method = _method
      chooser_init
      fltk_method_call
    }
    button.widget_type(FLTK::RADIO_BUTTON)
    @widgets << button
    y += 30
  }

  @chooser = FLTK::ColorChooser.new(100,30,200,90)
  @chooser.callback{ fltk_method_call }
  chooser_init
  @widgets << @chooser

  win.show
}

FLTK.run
